/***************************************************************************
 * tabsongsubject.h
 *
 * This file is part of KTabEdit, a KDE tabulature editor
 *
 * copyright (C) 2007- the KTabEdit development team <mrgwen@gmail.com>
 ***************************************************************************/

/***************************************************************************
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * See the file COPYING for more information.
 ***************************************************************************/

#ifndef TABSONGSUBJECT_H
#define TABSONGSUBJECT_H

#include <QList>

class TabSongObserver;
class TabTrack;

class TabSongSubject
{
public:
	TabSongSubject();
	virtual ~TabSongSubject();
	
	virtual void attach(TabSongObserver* o);
	virtual void detach(TabSongObserver* o);
	
	virtual void notifySongUpdated();
	virtual void notifyTrackAdded(TabTrack* track);
	virtual void notifyTrackDeleted(TabTrack* track);
	virtual void notifyPropertyChanged();
	virtual void notifyKeyChanged();
	virtual void notifyLyricsChanged();
	
private:
	typedef QList<TabSongObserver*>::iterator iterator;
	
	QList<TabSongObserver*> mObserver;
};

#endif
